#!/usr/bin/python
# -*- coding: utf-8 -*-

from sys import argv
from sys import exit

if len(argv) != 2:
    print "Usage: python parsereport.py <file>"
    exit()

code = "\033[%sm"


def error(txt):
    global code
    print "%s%s%sERROR:%s%s %s%s" % (
        code % 31, code % 7, code % 1, code % 0, code % 31, txt, code % 0)


def warning(txt):
    global code
    print "%s%sWARN: %s%s" % (
        code % 31, code % 2, txt, code % 0)


def list_join(l, t=" "):
    s = ""
    for i in l:
        s += i + t
    return s[:-1]

print ""
print "Parsing file %s" % (argv[1])

print "%sOpening file.%s" % (code % 2, code % 0)
try:
    f = open(argv[1], 'r')
except:
    error("Error opening file!")
    exit()

print "%sReading file.%s" % (code % 2, code % 0)
try:
    contents = f.readlines()
except:
    error("Error reading file!")
    exit()

line = 0
info = {}
sections = {}
layout = []

check = contents[0] == "{?{\n"
if check:
    while contents[line] != "}}\n":
        line += 1
        if contents[line].split("\n")[0].strip().split(" ")[0][0] == "@":
            info[contents[line].split(
                "\n")[0].strip().split(" ")[0][1:]] = list_join(
                    contents[line].split("\n")[0].strip().split(" ")[1:])

print "%sParsing file.%s" % (code % 2, code % 0)
inComment = False
section = None
subsection = None
for line in contents[line:]:
    l = line.split("\n")[0].strip()
    #print "%s%s%s" % (code % 34, l, code % 0)

    # Comment detection.
    if l == "{{{":
        inComment = True
    if l == "}}}" and inComment:
        inComment = False

    try:
        if not inComment and l[0] is not "~":
            if l.split(" ")[0] == "===" or l.split(" ")[0] == "==":
                section = list_join(l.split(" ")[1:-1])
                sections[section] = []
                layout.append("SECTION:\t" + list_join(l.split(" ")[1:-1]))
            if l.split(" ")[0] == "-":
                if section is not None:
                    sections[section].append(
                        (list_join(l.split(" ")[1:]), "subs"))
                    if l.split(" ")[-1] == "!Done" or l.split(
                            " ")[-1] == "!done":
                        doneMsg = "^"
                    else:
                        doneMsg = ""
                    if len(list_join(l.split(" ")[1:])) > 40:
                        layout.append("%s\tSUB:\t" % doneMsg + list_join(
                            l.split(" ")[1:])[:40] + "...")
                    else:
                        layout.append("%s\tSUB:\t" % doneMsg + list_join(
                            l.split(" ")[1:]))
                else:
                    error("Sub-section not inside a section!")
            if l.split(" ")[0] == ">":
                sections[section].append((list_join(l.split(" ")[1:]), "para"))
                print l.split(" ")[-1]

                msg = "\tPARA:\t"
                if len(list_join(l.split(" ")[1:])) > 40:
                    msg += l[2:40] + "..."
                else:
                    msg += l
                layout.append(msg)
            if l.split(" ")[0] == "*":
                if l.split(" ")[-1] == "!Done" or l.split(" ")[-1] == "!done":
                    doneMsg = "^"
                else:
                    doneMsg = ""
                layout.append("%sLONE:\t\t" % doneMsg + list_join(
                    l.split(" ")[1:]))
        else:
            #print "Found a comment!"
            pass
    except:
        #print "Empty line so clear section!"
        section = None
    #print "\n"
print "Finished!"

print ""
print "%sINFO:%s" % (code % 1, code % 0), info
print "%sSECTIONS:%s" % (code % 1, code % 0), sections
print "%sLAYOUT:%s" % (code % 1, code % 0)
for i in layout:
    print "%s%s%s" % (code % 2, i, code % 0)
print ""
